$(document).on("click", '#facebook_sign_up', facebookSignUp);

function facebookSignUp() {

    var successCalled = false;

    $('#sign_up_wait').show();
    $('#sign_up_choice').hide();
    $(window).resize();

    setTimeout(function(){
        facebookConnectPlugin.login(CONFIG_FBPERMS, success, fail);
    }, 1000);

    function success(response) { 

        if (successCalled) return;

        successCalled = true;

        localStorage.setItem("facebookAccessToken", response.authResponse.accessToken);

        var accessTokenLogin = 'https://' + CONFIG_DOMAIN + '/auth/facebook/token?access_token=' + encodeURI(response.authResponse.accessToken);

        if (CONFIG_HASBEARD) {
            accessTokenLogin = 'https://' + CONFIG_DOMAIN + '/auth/facebook/token?hasBeard=' + (globalUserChoice ? 'yes' : 'no') + '&access_token=' + encodeURI(response.authResponse.accessToken);
        }
        if (CONFIG_HASTATTOOS) {
            accessTokenLogin = 'https://' + CONFIG_DOMAIN + '/auth/facebook/token?hasTattoos=' + (globalUserChoice ? 'yes' : 'no') + '&access_token=' + encodeURI(response.authResponse.accessToken);
        }
       
        openInAppBrowser(accessTokenLogin);
    }

    function fail(response) {

        // We're unauthorised, we will automatically re-authorise
        if (response.errorCode == "190") {
            return;
        }


        if (CONFIG_HASBEARD) {
            $('#beard_choice').show();
        }

        if (CONFIG_HASTATTOOS) {
            $('#tattoos_choice').show();
        }

        $('#sign_up_wait').hide();
        $('#sign_up_choice').show();

        $.mobile.changePage("#page1");

        // user cancelled the request
        if (response.errorCode == "4201") {
            return;
        }
        
        alert(CONFIG_STRING_FACEBOOKERROR + " (" + response.errorCode + ")");
    }
}

function reLogInWithFacebookAccessToken() {
    var accessToken = facebookAccessToken();

    var accessTokenLogin = 'https://' + CONFIG_DOMAIN + '/auth/facebook/token?access_token=' + encodeURI(accessToken);

    openInAppBrowser(accessTokenLogin);
}

function logoutFacebook() {
    facebookConnectPlugin.logout(function(){}, function(){});
    localStorage.removeItem("facebookAccessToken");
}


function facebookAccessToken() {
    return localStorage.getItem("facebookAccessToken");
}